/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * Lanai Disassembler                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static void insertBits(InsnType &field, InsnType bits, unsigned startBit,
                       unsigned numBits) {
  if constexpr (std::is_integral<InsnType>::value) {
    assert(startBit + numBits <= sizeof field * 8);
    field |= (InsnType)bits << startBit;
  } else {
    field.insertBits(bits, startBit, numBits);
  }
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTableLanai32[] = {
/* 0 */       MCD::OPC_ExtractField, 28, 4,  // Inst{31-28} ...
/* 3 */       MCD::OPC_FilterValue, 0, 122, 0, // Skip to: 129
/* 7 */       MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 10 */      MCD::OPC_FilterValue, 0, 91, 0, // Skip to: 105
/* 14 */      MCD::OPC_ExtractField, 0, 16,  // Inst{15-0} ...
/* 17 */      MCD::OPC_FilterValue, 1, 10, 0, // Skip to: 31
/* 21 */      MCD::OPC_CheckField, 18, 10, 0, 74, 0, // Skip to: 101
/* 27 */      MCD::OPC_Decode, 230, 2, 0, // Opcode: NOP
/* 31 */      MCD::OPC_FilterValue, 2, 10, 0, // Skip to: 45
/* 35 */      MCD::OPC_CheckField, 18, 10, 0, 60, 0, // Skip to: 101
/* 41 */      MCD::OPC_Decode, 224, 2, 0, // Opcode: LOG0
/* 45 */      MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 59
/* 49 */      MCD::OPC_CheckField, 18, 10, 0, 46, 0, // Skip to: 101
/* 55 */      MCD::OPC_Decode, 225, 2, 0, // Opcode: LOG1
/* 59 */      MCD::OPC_FilterValue, 4, 10, 0, // Skip to: 73
/* 63 */      MCD::OPC_CheckField, 18, 10, 0, 32, 0, // Skip to: 101
/* 69 */      MCD::OPC_Decode, 226, 2, 0, // Opcode: LOG2
/* 73 */      MCD::OPC_FilterValue, 5, 10, 0, // Skip to: 87
/* 77 */      MCD::OPC_CheckField, 18, 10, 0, 18, 0, // Skip to: 101
/* 83 */      MCD::OPC_Decode, 227, 2, 0, // Opcode: LOG3
/* 87 */      MCD::OPC_FilterValue, 6, 10, 0, // Skip to: 101
/* 91 */      MCD::OPC_CheckField, 18, 10, 0, 4, 0, // Skip to: 101
/* 97 */      MCD::OPC_Decode, 228, 2, 0, // Opcode: LOG4
/* 101 */     MCD::OPC_Decode, 197, 2, 1, // Opcode: ADD_I_LO
/* 105 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 113
/* 109 */     MCD::OPC_Decode, 196, 2, 1, // Opcode: ADD_I_HI
/* 113 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 121
/* 117 */     MCD::OPC_Decode, 194, 2, 1, // Opcode: ADD_F_I_LO
/* 121 */     MCD::OPC_FilterValue, 3, 89, 3, // Skip to: 982
/* 125 */     MCD::OPC_Decode, 193, 2, 1, // Opcode: ADD_F_I_HI
/* 129 */     MCD::OPC_FilterValue, 1, 35, 0, // Skip to: 168
/* 133 */     MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 136 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 144
/* 140 */     MCD::OPC_Decode, 191, 2, 1, // Opcode: ADDC_I_LO
/* 144 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 152
/* 148 */     MCD::OPC_Decode, 190, 2, 1, // Opcode: ADDC_I_HI
/* 152 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 160
/* 156 */     MCD::OPC_Decode, 188, 2, 1, // Opcode: ADDC_F_I_LO
/* 160 */     MCD::OPC_FilterValue, 3, 50, 3, // Skip to: 982
/* 164 */     MCD::OPC_Decode, 187, 2, 1, // Opcode: ADDC_F_I_HI
/* 168 */     MCD::OPC_FilterValue, 2, 35, 0, // Skip to: 207
/* 172 */     MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 175 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 183
/* 179 */     MCD::OPC_Decode, 142, 3, 1, // Opcode: SUB_I_LO
/* 183 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 191
/* 187 */     MCD::OPC_Decode, 141, 3, 1, // Opcode: SUB_I_HI
/* 191 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 199
/* 195 */     MCD::OPC_Decode, 139, 3, 1, // Opcode: SUB_F_I_LO
/* 199 */     MCD::OPC_FilterValue, 3, 11, 3, // Skip to: 982
/* 203 */     MCD::OPC_Decode, 138, 3, 1, // Opcode: SUB_F_I_HI
/* 207 */     MCD::OPC_FilterValue, 3, 35, 0, // Skip to: 246
/* 211 */     MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 214 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 222
/* 218 */     MCD::OPC_Decode, 136, 3, 1, // Opcode: SUBB_I_LO
/* 222 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 230
/* 226 */     MCD::OPC_Decode, 135, 3, 1, // Opcode: SUBB_I_HI
/* 230 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 238
/* 234 */     MCD::OPC_Decode, 133, 3, 1, // Opcode: SUBB_F_I_LO
/* 238 */     MCD::OPC_FilterValue, 3, 228, 2, // Skip to: 982
/* 242 */     MCD::OPC_Decode, 132, 3, 1, // Opcode: SUBB_F_I_HI
/* 246 */     MCD::OPC_FilterValue, 4, 35, 0, // Skip to: 285
/* 250 */     MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 253 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 261
/* 257 */     MCD::OPC_Decode, 203, 2, 1, // Opcode: AND_I_LO
/* 261 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 269
/* 265 */     MCD::OPC_Decode, 202, 2, 1, // Opcode: AND_I_HI
/* 269 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 277
/* 273 */     MCD::OPC_Decode, 200, 2, 1, // Opcode: AND_F_I_LO
/* 277 */     MCD::OPC_FilterValue, 3, 189, 2, // Skip to: 982
/* 281 */     MCD::OPC_Decode, 199, 2, 1, // Opcode: AND_F_I_HI
/* 285 */     MCD::OPC_FilterValue, 5, 35, 0, // Skip to: 324
/* 289 */     MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 292 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 300
/* 296 */     MCD::OPC_Decode, 235, 2, 1, // Opcode: OR_I_LO
/* 300 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 308
/* 304 */     MCD::OPC_Decode, 234, 2, 1, // Opcode: OR_I_HI
/* 308 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 316
/* 312 */     MCD::OPC_Decode, 232, 2, 1, // Opcode: OR_F_I_LO
/* 316 */     MCD::OPC_FilterValue, 3, 150, 2, // Skip to: 982
/* 320 */     MCD::OPC_Decode, 231, 2, 1, // Opcode: OR_F_I_HI
/* 324 */     MCD::OPC_FilterValue, 6, 35, 0, // Skip to: 363
/* 328 */     MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 331 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 339
/* 335 */     MCD::OPC_Decode, 151, 3, 1, // Opcode: XOR_I_LO
/* 339 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 347
/* 343 */     MCD::OPC_Decode, 150, 3, 1, // Opcode: XOR_I_HI
/* 347 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 355
/* 351 */     MCD::OPC_Decode, 148, 3, 1, // Opcode: XOR_F_I_LO
/* 355 */     MCD::OPC_FilterValue, 3, 111, 2, // Skip to: 982
/* 359 */     MCD::OPC_Decode, 147, 3, 1, // Opcode: XOR_F_I_HI
/* 363 */     MCD::OPC_FilterValue, 7, 35, 0, // Skip to: 402
/* 367 */     MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 370 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 378
/* 374 */     MCD::OPC_Decode, 250, 2, 2, // Opcode: SL_I
/* 378 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 386
/* 382 */     MCD::OPC_Decode, 240, 2, 2, // Opcode: SA_I
/* 386 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 394
/* 390 */     MCD::OPC_Decode, 249, 2, 2, // Opcode: SL_F_I
/* 394 */     MCD::OPC_FilterValue, 3, 72, 2, // Skip to: 982
/* 398 */     MCD::OPC_Decode, 239, 2, 2, // Opcode: SA_F_I
/* 402 */     MCD::OPC_FilterValue, 8, 17, 0, // Skip to: 423
/* 406 */     MCD::OPC_CheckField, 0, 28, 252, 255, 219, 8, 4, 0, // Skip to: 419
/* 415 */     MCD::OPC_Decode, 238, 2, 0, // Opcode: RET
/* 419 */     MCD::OPC_Decode, 220, 2, 3, // Opcode: LDW_RI
/* 423 */     MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 431
/* 427 */     MCD::OPC_Decode, 144, 3, 3, // Opcode: SW_RI
/* 431 */     MCD::OPC_FilterValue, 10, 51, 0, // Skip to: 486
/* 435 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 438 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 446
/* 442 */     MCD::OPC_Decode, 217, 2, 4, // Opcode: LDHs_RR
/* 446 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 454
/* 450 */     MCD::OPC_Decode, 219, 2, 4, // Opcode: LDHz_RR
/* 454 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 462
/* 458 */     MCD::OPC_Decode, 221, 2, 4, // Opcode: LDW_RR
/* 462 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 470
/* 466 */     MCD::OPC_Decode, 222, 2, 4, // Opcode: LDWz_RR
/* 470 */     MCD::OPC_FilterValue, 4, 4, 0, // Skip to: 478
/* 474 */     MCD::OPC_Decode, 213, 2, 4, // Opcode: LDBs_RR
/* 478 */     MCD::OPC_FilterValue, 5, 244, 1, // Skip to: 982
/* 482 */     MCD::OPC_Decode, 215, 2, 4, // Opcode: LDBz_RR
/* 486 */     MCD::OPC_FilterValue, 11, 27, 0, // Skip to: 517
/* 490 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 493 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 501
/* 497 */     MCD::OPC_Decode, 131, 3, 4, // Opcode: STH_RR
/* 501 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 509
/* 505 */     MCD::OPC_Decode, 145, 3, 4, // Opcode: SW_RR
/* 509 */     MCD::OPC_FilterValue, 4, 213, 1, // Skip to: 982
/* 513 */     MCD::OPC_Decode, 129, 3, 4, // Opcode: STB_RR
/* 517 */     MCD::OPC_FilterValue, 12, 22, 1, // Skip to: 799
/* 521 */     MCD::OPC_ExtractField, 3, 8,  // Inst{10-3} ...
/* 524 */     MCD::OPC_FilterValue, 0, 19, 0, // Skip to: 547
/* 528 */     MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 531 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 539
/* 535 */     MCD::OPC_Decode, 198, 2, 5, // Opcode: ADD_R
/* 539 */     MCD::OPC_FilterValue, 1, 183, 1, // Skip to: 982
/* 543 */     MCD::OPC_Decode, 195, 2, 5, // Opcode: ADD_F_R
/* 547 */     MCD::OPC_FilterValue, 32, 19, 0, // Skip to: 570
/* 551 */     MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 554 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 562
/* 558 */     MCD::OPC_Decode, 192, 2, 5, // Opcode: ADDC_R
/* 562 */     MCD::OPC_FilterValue, 1, 160, 1, // Skip to: 982
/* 566 */     MCD::OPC_Decode, 189, 2, 5, // Opcode: ADDC_F_R
/* 570 */     MCD::OPC_FilterValue, 64, 19, 0, // Skip to: 593
/* 574 */     MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 577 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 585
/* 581 */     MCD::OPC_Decode, 143, 3, 5, // Opcode: SUB_R
/* 585 */     MCD::OPC_FilterValue, 1, 137, 1, // Skip to: 982
/* 589 */     MCD::OPC_Decode, 140, 3, 5, // Opcode: SUB_F_R
/* 593 */     MCD::OPC_FilterValue, 96, 19, 0, // Skip to: 616
/* 597 */     MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 600 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 608
/* 604 */     MCD::OPC_Decode, 137, 3, 5, // Opcode: SUBB_R
/* 608 */     MCD::OPC_FilterValue, 1, 114, 1, // Skip to: 982
/* 612 */     MCD::OPC_Decode, 134, 3, 5, // Opcode: SUBB_F_R
/* 616 */     MCD::OPC_FilterValue, 128, 1, 19, 0, // Skip to: 640
/* 621 */     MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 624 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 632
/* 628 */     MCD::OPC_Decode, 204, 2, 5, // Opcode: AND_R
/* 632 */     MCD::OPC_FilterValue, 1, 90, 1, // Skip to: 982
/* 636 */     MCD::OPC_Decode, 201, 2, 5, // Opcode: AND_F_R
/* 640 */     MCD::OPC_FilterValue, 160, 1, 67, 0, // Skip to: 712
/* 645 */     MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 648 */     MCD::OPC_FilterValue, 0, 52, 0, // Skip to: 704
/* 652 */     MCD::OPC_CheckField, 18, 10, 64, 16, 0, // Skip to: 674
/* 658 */     MCD::OPC_CheckField, 16, 1, 0, 10, 0, // Skip to: 674
/* 664 */     MCD::OPC_CheckField, 0, 3, 0, 4, 0, // Skip to: 674
/* 670 */     MCD::OPC_Decode, 210, 2, 6, // Opcode: JR
/* 674 */     MCD::OPC_CheckField, 23, 5, 2, 10, 0, // Skip to: 690
/* 680 */     MCD::OPC_CheckField, 11, 5, 0, 4, 0, // Skip to: 690
/* 686 */     MCD::OPC_Decode, 206, 2, 7, // Opcode: BRIND_CC
/* 690 */     MCD::OPC_CheckField, 23, 5, 2, 4, 0, // Skip to: 700
/* 696 */     MCD::OPC_Decode, 207, 2, 8, // Opcode: BRIND_CCA
/* 700 */     MCD::OPC_Decode, 236, 2, 5, // Opcode: OR_R
/* 704 */     MCD::OPC_FilterValue, 1, 18, 1, // Skip to: 982
/* 708 */     MCD::OPC_Decode, 233, 2, 5, // Opcode: OR_F_R
/* 712 */     MCD::OPC_FilterValue, 192, 1, 19, 0, // Skip to: 736
/* 717 */     MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 720 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 728
/* 724 */     MCD::OPC_Decode, 152, 3, 5, // Opcode: XOR_R
/* 728 */     MCD::OPC_FilterValue, 1, 250, 0, // Skip to: 982
/* 732 */     MCD::OPC_Decode, 149, 3, 5, // Opcode: XOR_F_R
/* 736 */     MCD::OPC_FilterValue, 224, 1, 10, 0, // Skip to: 751
/* 741 */     MCD::OPC_CheckField, 17, 1, 0, 235, 0, // Skip to: 982
/* 747 */     MCD::OPC_Decode, 242, 2, 9, // Opcode: SELECT
/* 751 */     MCD::OPC_FilterValue, 240, 1, 19, 0, // Skip to: 775
/* 756 */     MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 759 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 767
/* 763 */     MCD::OPC_Decode, 247, 2, 5, // Opcode: SHL_R
/* 767 */     MCD::OPC_FilterValue, 1, 211, 0, // Skip to: 982
/* 771 */     MCD::OPC_Decode, 246, 2, 5, // Opcode: SHL_F_R
/* 775 */     MCD::OPC_FilterValue, 248, 1, 202, 0, // Skip to: 982
/* 780 */     MCD::OPC_ExtractField, 17, 1,  // Inst{17} ...
/* 783 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 791
/* 787 */     MCD::OPC_Decode, 252, 2, 5, // Opcode: SRA_R
/* 791 */     MCD::OPC_FilterValue, 1, 187, 0, // Skip to: 982
/* 795 */     MCD::OPC_Decode, 251, 2, 5, // Opcode: SRA_F_R
/* 799 */     MCD::OPC_FilterValue, 13, 27, 0, // Skip to: 830
/* 803 */     MCD::OPC_ExtractField, 0, 18,  // Inst{17-0} ...
/* 806 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 814
/* 810 */     MCD::OPC_Decode, 237, 2, 10, // Opcode: POPC
/* 814 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 822
/* 818 */     MCD::OPC_Decode, 223, 2, 10, // Opcode: LEADZ
/* 822 */     MCD::OPC_FilterValue, 3, 156, 0, // Skip to: 982
/* 826 */     MCD::OPC_Decode, 146, 3, 10, // Opcode: TRAILZ
/* 830 */     MCD::OPC_FilterValue, 14, 62, 0, // Skip to: 896
/* 834 */     MCD::OPC_ExtractField, 1, 1,  // Inst{1} ...
/* 837 */     MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 861
/* 841 */     MCD::OPC_CheckField, 25, 3, 0, 10, 0, // Skip to: 857
/* 847 */     MCD::OPC_CheckField, 0, 1, 0, 4, 0, // Skip to: 857
/* 853 */     MCD::OPC_Decode, 209, 2, 11, // Opcode: BT
/* 857 */     MCD::OPC_Decode, 205, 2, 12, // Opcode: BRCC
/* 861 */     MCD::OPC_FilterValue, 1, 117, 0, // Skip to: 982
/* 865 */     MCD::OPC_ExtractField, 23, 2,  // Inst{24-23} ...
/* 868 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 882
/* 872 */     MCD::OPC_CheckField, 2, 16, 0, 104, 0, // Skip to: 982
/* 878 */     MCD::OPC_Decode, 241, 2, 13, // Opcode: SCC
/* 882 */     MCD::OPC_FilterValue, 2, 96, 0, // Skip to: 982
/* 886 */     MCD::OPC_CheckField, 16, 7, 0, 90, 0, // Skip to: 982
/* 892 */     MCD::OPC_Decode, 208, 2, 14, // Opcode: BRR
/* 896 */     MCD::OPC_FilterValue, 15, 82, 0, // Skip to: 982
/* 900 */     MCD::OPC_ExtractField, 16, 2,  // Inst{17-16} ...
/* 903 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 911
/* 907 */     MCD::OPC_Decode, 211, 2, 15, // Opcode: LDADDR
/* 911 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 919
/* 915 */     MCD::OPC_Decode, 255, 2, 15, // Opcode: STADDR
/* 919 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 927
/* 923 */     MCD::OPC_Decode, 248, 2, 15, // Opcode: SLI
/* 927 */     MCD::OPC_FilterValue, 3, 51, 0, // Skip to: 982
/* 931 */     MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 934 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 942
/* 938 */     MCD::OPC_Decode, 216, 2, 16, // Opcode: LDHs_RI
/* 942 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 950
/* 946 */     MCD::OPC_Decode, 218, 2, 16, // Opcode: LDHz_RI
/* 950 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 958
/* 954 */     MCD::OPC_Decode, 130, 3, 16, // Opcode: STH_RI
/* 958 */     MCD::OPC_FilterValue, 4, 4, 0, // Skip to: 966
/* 962 */     MCD::OPC_Decode, 212, 2, 16, // Opcode: LDBs_RI
/* 966 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 974
/* 970 */     MCD::OPC_Decode, 214, 2, 16, // Opcode: LDBz_RI
/* 974 */     MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 982
/* 978 */     MCD::OPC_Decode, 128, 3, 16, // Opcode: STB_RI
/* 982 */     MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  llvm_unreachable("Invalid index!");
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 23, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 18, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 23, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 18, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    if (!Check(S, decodeShiftImm(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 23, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 23);
    if (!Check(S, decodeRiMemoryValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 23, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 3, 8), 0, 8);
    insertBits(tmp, fieldFromInstruction(insn, 11, 5), 10, 5);
    insertBits(tmp, fieldFromInstruction(insn, 16, 2), 8, 2);
    insertBits(tmp, fieldFromInstruction(insn, 18, 5), 15, 5);
    if (!Check(S, decodeRrMemoryValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 23, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 18, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 1, 3);
    insertBits(tmp, fieldFromInstruction(insn, 16, 1), 0, 1);
    if (!Check(S, decodePredicateOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 11, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 18, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 1, 3);
    insertBits(tmp, fieldFromInstruction(insn, 16, 1), 0, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 18, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 1, 3);
    insertBits(tmp, fieldFromInstruction(insn, 16, 1), 0, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 23, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 18, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 1, 3);
    insertBits(tmp, fieldFromInstruction(insn, 16, 1), 0, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 23, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 18, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 2, 23) << 2;
    if (!Check(S, decodeBranch(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 2, 23) << 2;
    if (!Check(S, decodeBranch(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 1), 0, 1);
    insertBits(tmp, fieldFromInstruction(insn, 25, 3), 1, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 18, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 1), 0, 1);
    insertBits(tmp, fieldFromInstruction(insn, 25, 3), 1, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 2, 14) << 2;
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 1), 0, 1);
    insertBits(tmp, fieldFromInstruction(insn, 25, 3), 1, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 23, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 16), 0, 16);
    insertBits(tmp, fieldFromInstruction(insn, 18, 5), 16, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 23, 5);
    if (!Check(S, DecodeGPRRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 12), 0, 12);
    insertBits(tmp, fieldFromInstruction(insn, 18, 5), 12, 5);
    if (!Check(S, decodeSplsValue(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  }
}

static unsigned decodeNumToSkip(const uint8_t *&Ptr) {
  unsigned NumToSkip = *Ptr++;
  NumToSkip |= (*Ptr++) << 8;
  return NumToSkip;
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr++) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr++;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      uint64_t Val = decodeULEB128AndIncUnsafe(Ptr);
      bool Failed = Val != CurFieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the filter operation.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << (Failed ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      bool Failed = ExpectedValue != FieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // If the actual and expected values don't match, skip.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << (Failed ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);
      // Check the predicate.
      bool Failed = !checkDecoderPredicate(PIdx, Bits);
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Failed ? "FAIL\n" : "PASS\n"));

      break;
    }
    case MCD::OPC_Decode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      uint64_t PositiveMask = decodeULEB128AndIncUnsafe(Ptr);
      uint64_t NegativeMask = decodeULEB128AndIncUnsafe(Ptr);
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // namespace
